#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

void finish(string rep = "incorrect query"){
    cout << "-1" << endl;
    cout.flush();
    quitf(_wa, rep.c_str());
}

int readType() {
    string s = ouf.readWord();
    if (s.size() > 1) {
        finish();
    }
    if (s[0] == '?') {
        return 1;
    }
    if (s[0] == '!') {
        return 2;
    }
    finish();
}

int readInt(int l, int r){ //this DOES NOT work with negative numbers
    string s = ouf.readWord();
    if (s.size() > 9){
        finish();
    }
    for(char c : s){
        if(c < '0' || '9' < c){
            finish();
        }
    }
    if(s.size() > 1 && s[0] == '0'){
        finish();
    }
    int ans = 0;
    for(char c : s){
        ans *= 10;
        ans += (c - '0');
    }
    if(ans < l || ans > r){
        finish();
    }
    return ans;
}

const int I5 = 1000 * 100;
const int max_n = 10001;

const int r_q[] = {16, 16, 16, 11, 11, 11, 300};

int main(int argc, char* argv[])
{
    registerInteraction(argc, argv);


    int n = inf.readInt(1, 10000, "n");
    inf.readSpace();
    int k = inf.readInt(1, n, "k");
    inf.readSpace();
    int pos = inf.readInt(1, n - k + 1, "start");
    inf.readSpace();
    int g = inf.readInt(0, 10, "g");
    inf.readEoln();
    int q = r_q[g];
    vector <int> w = inf.readInts(n, 1, I5, "w");
    inf.readEoln();

    cout << n << ' ' << k << ' ' << g << endl;
    int left = q + 1;
    bool get_answer = false;
    bitset <max_n> have1, have2;

    while (left > 0) {
        --left;
        int type = readType();
        if (type == 2) {
            int answer = readInt(1, n);
            tout << answer << endl;
            get_answer = true;
            break;
        }
        else {
            int m1 = readInt(1, n);
            int m2 = readInt(1, n);
            have1.reset();
            have2.reset();

            vector<int> a(m1), b(m2);
            int s = 0;
            for (int i = 0; i < m1; i++){
                a[i] = readInt(1, n);
                if (have1[a[i]]) {
                    finish("equal elements in a");
                }
                have1[a[i]] = 1;
                s += w[a[i] - 1];
            }
            for (int i = 0; i < m2; i++){
                b[i] = readInt(1, n);
                if (have2[b[i]]) {
                    finish("equal elements in b");
                }
                have2[b[i]] = 1;
                s -= w[b[i] - 1];
            }
            if ((have1 & have2).any()) {
                finish("There are common elements");
            }
            if (s > 0) {
                cout << 1;
            }
            else if (s < 0) {
                cout << 2;
            }
            else {
                cout << 0;
            }
            cout << endl;
        }
    }
    if (!get_answer) {
        finish("Answer wasn't given");
    }
    int mx = q - left;
    tout << mx << endl;
    inf.readEof();
    quitf(_ok, "Used %d queries", mx);
}
